/*
 *	LaMoSca.C
 *	LAboratorio di MOtori per SCAcchi
 *	versione 0.02
 *	2001 Pietro Valocchi
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Common.h"


int  ChiMuove;			/* colore che deve muovere */
FILE *LogFile = NULL;	/* id log file */


/* rappresentazione della scacchiera: vettore con due interi per ogni casa */
/* Colore = BIANCO, NERO o VUOTO */
/* Pezzo = PEDONE, CAVALLO, ALFIERE, TORRE, DONNA, RE o VUOTO */
Casa B[NUMEROCASE]; 


/* lettere dei pezzi bianchi per la VisualizzaScacchiera() 
   in accordo con i define in Common.h */
char SimboliPezziBianco[NUMEROPEZZI] = "PNBRQK";
/* lettere dei pezzi neri per la VisualizzaScacchiera() 
   in accordo con i define in Common.h  */
char SimboliPezziNero[NUMEROPEZZI] = "pnbrqk";


/* VisualizzaScacchiera() visualizza la posizione dei pezzi */
void VisualizzaScacchiera() {
	int i;
	
	printf("\n8 ");
	for (i = 0; i < NUMEROCASE; i++) {
		switch (B[i].Colore) {
			case BIANCO:
				printf(" %c", SimboliPezziBianco[B[i].Pezzo]);
				break;
			case NERO:
				printf(" %c", SimboliPezziNero[B[i].Pezzo]);
				break;
			case VUOTO:
				printf(" .");
				break;
		}
		if ((i + 1) % CASEPERRIGA == 0 && i != (NUMEROCASE - 1))
			printf("\n%d ", 7 - RIGA(i));
	}
	printf("\n\n   a b c d e f g h\n\n");
}


/* main()  un loop che gestisce il prompt dei comandi */
int main(int argc, char **argv) {
	char Command[256];	/* riga di comando */

	if (argc > 1)
		if (!strcmp(argv[1],"log")) {
			LogFile=fopen("LaMoScaLogFile.txt","w");
			if (LogFile) fprintf(LogFile, "LaMoSca v0.02 Log File\n");
			else printf("Impossibile aprire il file di log\n");
		}

	printf("\n");
	printf("LaMoSca (LAboratorio di MOtori per SCAcchi)\n");
	printf("versione 0.02\n");
	printf("\n");
	printf("\"help\" mostra la lista dei comandi.\n");
	printf("\n");

	Inizializza();
	VisualizzaScacchiera();

	while (TRUE) {

		/* prende l'input da consolle */
		printf("LaMoSca> ");
		if (scanf("%s", Command) == EOF)
			return 0;

		/* interpreta l'input come comando */
		if (!strcmp(Command, "help")) {
			printf("new   - nuova partita\n");
			printf("quit  - fine del programma\n");
			printf("d     - visualizza la scacchiera\n");
			printf("mosse - inserisci le coordinate; es.: e2e4\n");
			continue;
		}

		if (!strcmp(Command, "new")) {
			Inizializza();
			VisualizzaScacchiera();
			continue;
		}

		if (!strcmp(Command, "d")) {
			VisualizzaScacchiera();
			continue;
		}

		if (!strcmp(Command, "quit")) {
			printf("LaMoSca> Ciao!\n");
			if (LogFile)
				fclose(LogFile);
			return 0;
		}

		/* interpreta l'input come coordinate di una mossa */
		if (InputMossa(Command) == TRUE) {
			/* mossa accettata, mostra il risultato */
			VisualizzaScacchiera();
			/* cambia colore */
			ChiMuove ^= 1;
		} else {
			/* Comando non valido */
			printf("LaMoSca> Comando non valido\n");
		}
	}
}

